package code
package snippet

import java.util.Date

import net.liftweb.http._
import net.liftweb.util._
import net.liftweb.common._
import Helpers._
import lib._
import org.specs2.mutable.Specification
import org.specs2.specification.AroundEach
import org.specs2.execute.AsResult
import org.specs2.execute.Result


object HelloWorldTestSpecs extends Specification with AroundEach {
  val session = new LiftSession("", randomString(20), Empty)
  val stableTime: Date = (10 minutes) ago


  /**
   * For additional ways of writing tests,
   * please see http://www.assembla.com/spaces/liftweb/wiki/Mocking_HTTP_Requests
   */
  def around[T : AsResult](body: =>T): Result = {
    S.initIfUninitted(session) {
      DependencyFactory.time.doWith(stableTime) {
        AsResult(body) // execute t inside a http session
      }
    }
  }

  "HelloWorld Snippet" should {
    "Put the time in the node" in {
      val hello = new HelloWorld

      val str = hello.howdy(<span>Welcome to your Lift app at <span id="time">Time goes here</span></span>).toString

      str.indexOf(stableTime.toString) must be >= 0
      str must startWith("<span>Welcome to")
    }
  }
}
